var punch = require('./punch');
var stun = require('./stun');

exports.connect = (irc, to, rinfo) => new Promise((res, rej) =>
stun('stun.ucsb.edu').then(socket => {
  var onrinfo = (rinfo) => {
    socket.rinfo = rinfo;
    setTimeout(
      ()=>punch(socket).then(res).catch(rej),
      rinfo.punchTime - Date.now()
    );
    irc.removeListener('message', onmsg);
  };
  var onmsg = (e) => {
    if (e.from === to)
      onrinfo(JSON.parse(e.message));
  };
  if (rinfo) {
    socket.linfo.punchTime = rinfo.punchTime = Date.now() + 5000;
    onrinfo(rinfo);
  } else {
    irc.on('message', onmsg);
  }
  irc.send(to, JSON.stringify(socket.linfo));
}).catch(rej));

exports.createServer = (irc, cb) => {
  irc.on('message', e => {
    var rinfo = JSON.parse(e.message);
    exports.connect(irc, e.from, rinfo).then(cb).catch(console.error);
  });
};

exports.Socket = function (_socket, lport, rport, onrecv) {
  this._socket = _socket;

  this.sendBuf = new Buffer(4);
  this.sendBuf.writeUInt16LE(lport, 0);
  this.sendBuf.writeUInt16LE(rport, 2);

  this.recvBuf = new Buffer(4);
  this.recvBuf.writeUInt16LE(rport, 0);
  this.recvBuf.writeUInt16LE(lport, 2);
  this.recvNum = this.recvBuf.readUInt32LE(0);

  this.onrecv = onrecv;
  this.onmsg = (msg) => {
    if (msg.length > 4 && msg.slice(0, 4).readUInt32LE(0) === this.recvNum)
      this.onrecv(msg.slice(4));
  };

  this._socket.on('message', this.onmsg);
  this._socket.on('error', () => {
    this._socket.removeListener('message', this.onmsg);
  });
};

exports.Socket.prototype.send = function (msg) {
  this._socket.send(Buffer.concat(this.sendBuf, msg),
    this._socket.rinfo.port, this._socket.rinfo.address);
};
